class SearchController < ApplicationController
  include SearchEngine::OrientdbLucene

  def index
    @types = learning_object_repository.types

    @subjects = Subject.default_list

    @school_levels = ['Educação Infantil', 'Ensino Fundamental', 'Ensino Médio']

    @source = institution_repository.all
  end

  def fetch
    objectsFound = []

    params[:subject]= params[:subject].split(', ') unless params[:subject].nil?
    params[:type] = params[:type].split(', ') unless params[:type].nil?
    params[:school_level] = params[:school_level].split(', ') unless params[:school_level].nil?
    params[:year] = params[:year].split('-').take(2) unless params[:year].nil?
    page=1
    if (params[:page])
      page = params[:page].to_i
    end

    @pagination_limit=10

    unless params[:query].blank?
      objectsFound = search params
      @numFound = objectsFound.length
    end

    @result = Kaminari.paginate_array(objectsFound).page(page).per(@pagination_limit)
    @last_page = (@result.num_pages <= page) ? true : false;

    # build objects from one page only
    @objects = GenericBuilder.build(@result)

    render partial: 'search/fetch'
  end

  def autocomplete
    begin
      auto = AutocompleteService.new
      query = params['q'] || ''
      json_data = auto.query(query)
      render text: json_data
    rescue
      render text: '[]'
    end
  end

end
