class Collection < ActiveRecord::Base
  include Reviewable
  include Sociable
  include Followable

  has_many :collection_items
  has_many :collection_items, as: :collectionable
  has_many :collections, through: :collection_items, source: :collectionable, source_type: 'Collection'
  has_many :learning_objects, through: :collection_items, source: :collectionable, source_type: 'LearningObject'

  belongs_to :owner, polymorphic: true

  def owner?(candidate)
    owner == candidate
  end
end
