class LearningObject < ActiveRecord::Base
  include Metadatable
  include Reviewable
  include Sociable

  has_and_belongs_to_many :topics

  has_many :collection_items, as: :collectionable
  has_many :collections, through: :collection_items

  has_many :complaints
  has_many :attachments, class_name: 'LearningObject::Attachment'

  belongs_to :publisher, polymorphic: true

  def categories
    get_metadata_value_of 'dc.subject.category'
  end
end
