/*
 *  This file is part of Autocomplete-Server
 *
 *  Autocomplete-Server is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Foobar is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



/*===============================  HEADER  ==================================*/

#include "task.hpp"
#include <stdio.h>
#include <stdlib.h>
#include "util.hpp"

using namespace std;

/*---------------------------------------------------------------------------*/



/*================================  RESULT  =================================*/

Result::Result(){
	min = 0.0;
	size = 5;
}

void Result::push(std::string word, float fator){
	if (fator<min)
		return;
	if ( words.size() < size ){
		this->words.push_back(word);
		this->fators.push_back(fator);
		this->min = fator;
	} else {
		this->words.erase( this->words.begin() );
		this->fators.erase( this->fators.begin() );
		this->words.push_back(word);
		this->fators.push_back(fator);
		this->min = fator;
	}
}

std::string Result::json(){
	string res;
	res += "[";
	if ( words.size() > 0 ){
		for (int i=words.size()-1; i>0; i--){
			res += "{\"data\":\""+base+words[i]+"\",\"value\":\""+base+words[i]+"\"},";
		}
		res += "{\"data\":\""+base+words[0]+"\",\"value\":\""+base+words[0]+"\"}";
	}
	res += "]";
	return res;
}

/*---------------------------------------------------------------------------*/



/*=================================  TASK  ==================================*/

void Task::load(std::string filename){
	FILE* fp = fopen(filename.c_str(),"r");
	char buffer[2048];
	while ( !feof(fp) ){
		fscanf(fp,"%s",buffer);
		words.push_back(buffer);
	}
	fclose(fp);
	int size = words.size();
	printf("Qtde: %d\n",size);
}

std::string Task::find(std::string _query){
	Result result;

	string query;
	vector<string> query_words;
	explode(query_words,' ',_query);
	int last;
	for (last=query_words.size()-1; last>=0; last--){
		if ( query_words[last] != "" ){
			query = query_words[last];
			break;
		}
	}

	string base;
	for (int i=0; i<last; i++){
		base += query_words[i];
		base += " ";
	}
	result.base = base;


	for (int i=0; i<words.size(); i++){
		string& word = words[i];
		float fator = 0.0;
		int size = min(query.size(), word.size());
		//int diff_size = abs(query.size() - word.size());

		for (int j=0; j<size; j++){
			int diff = abs(query[j] - word[j]);
			if ( diff == 0 )
				fator += 100.0;
		}
		result.push(word, fator);
	}


	return result.json();
}

/*---------------------------------------------------------------------------*/




