/*
 *  This file is part of Autocomplete-Server
 *
 *  Autocomplete-Server is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Foobar is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef TASK_HPP
#define TASK_HPP



/*===============================  INCLUDES  ================================*/

#include <string>
#include <vector>

/*---------------------------------------------------------------------------*/



/*================================  RESULT  =================================
 * This classe has the responsibility of save the N bests results and convert
 * of a vector of words to the format json.
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


class Result{
  public:
	std::string base;
	std::vector<std::string> words;
	std::vector<float> fators;
	float min, size;

	Result();
	void push(std::string word, float fator);
	std::string json();
};

/*---------------------------------------------------------------------------*/



/*=================================  TASK  ==================================
 * This classe has the responsibility of search the best matches for a word
 * and it has in memory the all words in dictionary.
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

class Task{
	std::vector<std::string> words;

  public:
	void load(std::string filename);
	std::string find(std::string query);
};

/*---------------------------------------------------------------------------*/



#endif


