module Log
  class DatabaseLogger < Logger

    CREATE = 5
    SELECT = 6
    UPDATE = 7
    DELETE = 8

    SEVS = %w(DEBUG INFO WARN ERROR FATAL CREATE SELECT UPDATE DELETE)
    def format_severity(severity)
      SEVS[severity] || 'ANY'
    end

    def create(progname = nil, &block)
      add(5, nil, progname, &block) unless @db_lvl < 5
    end

    def select(progname = nil, &block)
      add(6, nil, progname, &block) unless @db_lvl < 6
    end

    def update(progname = nil, &block)
      add(7, nil, progname, &block) unless @db_lvl < 7
    end

    def delete(progname = nil, &block)
      add(8, nil, progname, &block) unless @db_lvl < 8
    end

    def level=(lvl)
      @db_lvl = lvl
      @level = lvl >= 5 ? 1 : lvl
    end

  end
end